models/Drug.php
<?php

namespace app\models;

use app\components\DataMocker;
use Yii;

/**
 * This is the model class for table "drug".
 *
 * @property integer $id
 * @property string $name
 * @property string $description
 * @property string $reference
 *
 * @property Category[] $categories
 * @property Stock[] $stock
 * @property DrugSubscription[] $subscriptions
 * @property string image
 */
class Drug extends \yii\db\ActiveRecord
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return 'drug';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        return [
            [['description'], 'string'],
            [['name', 'reference'], 'string', 'max' => 255],
        ];
    }

    /**
     * @inheritdoc
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'name' => 'Name',
            'description' => 'Description',
            'reference' => 'Reference',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery|Category[]
     */
    public function getCategories()
    {
        return $this->hasMany(Category::className(), ['id' => 'category_id'])
            ->viaTable('drug_category', ['drug_id'=>'id']);
    }
    
    public function getImage(){
      return DataMocker::randomImageUrl();
    }

    /**
     * @return \yii\db\ActiveQuery|Stock[]
     */
    public function getStock()
    {
        return $this->hasMany(Stock::className(), ['drug_id' => 'id']);
    }

    /**
     * @return \yii\db\ActiveQuery|DrugSubscription[]
     */
   public function getSubscriptions()
   {
       return $this->hasMany(DrugSubscription::className(), ['drug_id' => 'id']);
   }
}

controllers/DrugsController.php
<?php

namespace app\controllers;

use app\components\Mail;
use app\models\DrugSubscription;
use app\models\Subscriber;
use Yii;
use app\models\Drug;
use app\models\search\Drug as DrugSearch;
use yii\swiftmailer\Mailer;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use app\models\search\Stock as StockSearch;
use yii\web\Response;

/**
 * DrugsController implements the CRUD actions for Drug model.
 */
class DrugsController extends Controller
{
    /**
     * @inheritdoc
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    public $defaultAction = 'search';

    /**
     * Lists all Drug models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new DrugSearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }
    
    public function actionSearch()
    {
        $searchModel = new DrugSearch();
        $dataProvider = $searchModel->nameSearch(Yii::$app->request->queryParams);

        return $this->render('search', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Drug model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }
    
    public function actionInfo($id)
    {
        $searchModel = new StockSearch();
        $params = Yii::$app->request->queryParams;
        $params['Stock']['drug_id'] = $id;
        $dataProvider = $searchModel->search($params);

        return $this->render('info', [
            'subscriber'=>new Subscriber(),
            'model' => $this->findModel($id),
            'stockSearchModel' => $searchModel,
            'stockDataProvider' => $dataProvider,
        ]);
    }

    /**
     * Creates a new Drug model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Drug();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Updates an existing Drug model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        } else {
            return $this->render('update', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Deletes an existing Drug model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Drug model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Drug the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Drug::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }

    public function actionSubscribe($id){
        $drug = $this->findModel($id);
        $subscriber = new Subscriber();
        
        if(($subscriber->load(Yii::$app->request->post())) && $subscriber->validate()){
            $subscription = DrugSubscription::find()
                ->where(['drug_id'=>$id, 'email'=>$subscriber->email])->one();
            if($subscription == null){
                $subscription = new DrugSubscription();
                $subscription->attributes = $subscriber->attributes;
                $subscription->drug_id = $id;
                if($subscription->save())
                    Mail::sendSubscriptionEmail($drug, $subscriber);
            }
        }

        $this->redirect(['/drugs/info', 'id'=>$id]);

    }
}

controllers/PharmaciesController.php
<?php

namespace app\controllers;

use app\models\User;
use Yii;
use app\models\Pharmacy;
use app\models\search\Pharmacy as PharmacySearch;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use app\models\search\Stock as StockSearch;

/**
 * PharmaciesController implements the CRUD actions for Pharmacy model.
 */
class PharmaciesController extends Controller
{
    public $layout = '@app/views/pharmacies/layout';
    /**
     * @inheritdoc
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Pharmacy models.
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new PharmacySearch();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);

        return $this->render('index', [
            'searchModel' => $searchModel,
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Pharmacy model.
     * @param integer $id
     * @return mixed
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }
    
    public function actionInfo($id)
    {
        $searchModel = new StockSearch();
        $params = Yii::$app->request->queryParams;
        $params['Stock']['pharmacy_id'] = $id;
        $dataProvider = $searchModel->search($params);

        return $this->render('info', [
            'model' => $this->findModel($id),
            'stockSearchModel' => $searchModel,
            'stockDataProvider' => $dataProvider,
        ]);
    }

    /**
     * Creates a new Pharmacy model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $user = User::getCurrent();
        if($user->pharmacy_id != null)
            return $this->redirect(['view', 'id' => $user->pharmacy_id]);
        
        $model = new Pharmacy();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            $user->pharmacy_id = $model->id;
            $user->update();
            return $this->redirect(['view', 'id' => $model->id]);
        } else {
            return $this->render('create', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Updates an existing Pharmacy model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        } else {
            return $this->render('update', [
                'model' => $model,
            ]);
        }
    }

    /**
     * Deletes an existing Pharmacy model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Pharmacy model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Pharmacy the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Pharmacy::findOne($id)) !== null) {
            return $model;
        } else {
            throw new NotFoundHttpException('The requested page does not exist.');
        }
    }
}

views/drugs/_drug_search_view.php
<?php

use yii\helpers\Html;
use yii\helpers\Url;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Drug */

?>
<div class="drug-view">

    <div class="panel">
        <div class="panel-heading col-md-12">
            <h1 class="panel-title">
                <?= Html::a(Html::encode($model->name), ['info', 'id'=>$model->id], ['style'=>'font-size:20px']) ?>
            </h1>
        </div>
        <div class="panel-body">
            <div class="row">
                <div class="col-md-3">
                    <?=Html::img($model->image, ['style'=>'max-height:250px', 'class'=>'img-responsive '])?>
                </div>
                <div class="col-md-9">
                    <?php if(isset($model->description)):?>
                        <p><?=$model->description?></p>
                    <?php endif;?>

                    <?=$this->render('@app/views/categories/_list', ['categories'=>$model->categories])?>
                    <hr>
                    <div class="">
                        <a href="<?=Url::to(['info', 'id'=>$model->id])?>"><i class="fa fa-search"></i> Find Pharmacy</a> |
                        <a href="<?=$model->reference?>"><i class="fa fa-globe"></i> More Info</a>
                    </div>
                </div>
                <!--<span class="row pull-right">Reference: <?/*=Html::a('druginfo.nlm.nih.gov', $model->reference)*/?></span>-->
            </div>

        </div>
    </div>

</div>

views/drugs/_filter.php
<?php
use yii\helpers\Html;
/**
 * @var $searchModel \app\models\search\Drug
 */
?>

<div class="form-group">
    <?=Html::activeInput('text', $searchModel, 'name', ['class'=>'form-control'])?>
</div>

views/drugs/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Drug */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="drug-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'name')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'description')->textarea(['rows' => 6]) ?>

    <?= $form->field($model, 'reference')->textInput(['maxlength' => true]) ?>

    <div class="form-group">
        <?= Html::submitButton($model->isNewRecord ? 'Create' : 'Update', ['class' => $model->isNewRecord ? 'btn btn-success' : 'btn btn-primary']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/drugs/_list.php
<?php
/**
 * @var $drugs \app\models\Drug[]
 */
use yii\helpers\Html;
$total = count($drugs);
$suffix = $total == 1 ? '' : 's'?>

<?php if(!empty($drugs)):?>
    <br>
    <div class="col-md-12">
        <h4><?=$total.' drug'.$suffix?> in this category</h4>
        <ul class="">
            <?php foreach ($drugs as $drug)
                echo '<li style="list-style-type: none" class="col-md-3">' . ' &DoubleRightArrow; ' .
                    Html::a($drug->name, ['/drugs/info', 'id'=>$drug->id]) .
                    '</li>'?>
        </ul>
    </div>
<?php endif;?>

views/drugs/_search.php
<?php

use yii\helpers\Html;
use yii\helpers\Url;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\search\Drug */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="drug-search">

    <?php $form = ActiveForm::begin([
        'action' => ['search'],
        'method' => 'get',
    ]); ?>

    <div class="input-group">
        <?= Html::activeInput('text', $model, 'name', ['class'=>'form-control']) ?>

        <div class="input-group-btn">
            <?= Html::submitButton('Search', ['class' => 'btn btn-primary']) ?>
            <?= Html::resetButton('Reset', ['class' => 'btn btn-default', 'onclick'=>'window.location=\''.Url::to(['/drugs']).'\'']) ?>
        </div>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/drugs/_search_horizontal.php
<?php
/**
 * 
 */
use yii\helpers\Url; ?>
<form action="<?=Url::to(['/drugs'])?>" class="appoinment-form form-horizontal" style="border: none">
    <div class="input-group">
        <input name="Drug[name]" type="text" class="form-control" placeholder="Enter drug/illness e.g. amoxil, flu, cough ...">
        <span class="input-group-btn">
            <button type="submit" class="btn-submit" style="margin-top: 3px; max-height: 38px">
            <i class="fa fa-search-plus"></i> Search</button>
        </span>
    </div>
</form>

views/drugs/_subscribe.php
<?php
use yii\helpers\Html;
use yii\helpers\Url;
/**
 * @var $this \yii\web\View
 * @var $drug \app\models\Drug
 * @var $subscriber \app\models\Subscriber
 */
$host = Yii::$app->params['server_name'];
?>

<p>Subscribe below to receive notification whenever <?=$drug->name?> is stocked in any of our partner pharmacies</p>

<div class="drug-subscribe-form">
    <?= Html::beginForm(Url::to(['/drugs/subscribe', 'id'=>$drug->id]), 'post', ['class'=>'appoinment-form form-horizontal']); ?>

    <div class="input-group">
        <div class="form-group col-md-6">
            <?= Html::activeInput('text', $subscriber, 'name', ['class'=>'form-control', 'placeholder'=>'John Smith'])?>
        </div>
        <div class="form-group col-md-6">
            <?= Html::activeInput('email', $subscriber, 'email', [
                'class'=>'form-control col-md-6', 'placeholder'=>"john.smith@$host"
        ])?>
        </div>
        <span class="input-group-btn">
            <?= Html::submitButton('Subscribe', ['class'=>'btn btn-submit'])?>
        </span>
    </div>

    <?= Html::endForm(); ?>
</div>

<style>
    form.appoinment-form {
        border: none
    }
    div.drug-subscribe-form .input-group .form-group {
        padding: 0;
    }
    div.drug-subscribe-form .input-group span.input-group-btn button{
        margin-left: -45px;
        margin-top: -14px;
        max-height: 38px
    }
</style>

views/drugs/create.php
<?php

use yii\helpers\Html;


/* @var $this yii\web\View */
/* @var $model app\models\Drug */

$this->title = 'Create Drug';
$this->params['breadcrumbs'][] = ['label' => 'Drugs', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="drug-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/drugs/index.php
<?php

use app\models\Drug;
use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $searchModel app\models\search\Drug */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Drugs';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="drug-index">

    <h1><?= Html::encode($this->title) ?></h1>
    <?php // echo $this->render('_search', ['model' => $searchModel]); ?>

    <p>
        <?= Html::a('Create Drug', ['create'], ['class' => 'btn btn-success']) ?>
    </p>
    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'filterModel' => $searchModel,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            //'id',
            'name',
            'description:ntext',
            ['attribute'=>'reference', 'format'=>'raw', 'value'=>function(Drug $drug){
                return Html::a('Reference', $drug->reference);
            }],

            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>
</div>

views/drugs/info.php
<?php

use app\components\Constants;
use app\components\Listings;
use app\models\Stock;
use yii\grid\GridView;
use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Drug */
/* @var $stockSearchModel app\models\search\Stock */
/* @var $stockDataProvider yii\data\ActiveDataProvider */
/* @var $subscriber \app\models\Subscriber */

$this->title = $model->name;
$this->params['breadcrumbs'][] = ['label' => 'Drugs', 'url' => ['search']];
$this->params['breadcrumbs'][] = $this->title;
$categories = Listings::drugCategories($model);
$noCategories = count($categories);
$suffix = $noCategories == 1  ? 'category ' : ' categories; ';
$catList = $noCategories == 0
    ? '' : " {$model->name} is in the $suffix".implode(', ', $categories).'. '?>

<div class="drug-view">

    <h1 class="col-md-12">
        <?= Html::a('&lt; Back to Search', ['drugs/search'], ['class'=>'btn btn-default pull-right'])?>
        <?= Html::encode($this->title) ?>
    </h1>

    <div>
        <div class="col-md-3"><?=Html::img($model->image)?></div>
        <div class="col-md-9">
            <?=trim($model->description. $catList.
                ' Visit '.Html::a($model->reference, $model->reference)." to learn more about {$model->name}.")?>
            <br><br>

            <?=$this->render('@app/views/drugs/_subscribe', [
                'drug'=>$model,
                'subscriber'=>$subscriber
            ])?>
            <?=$this->render('@app/views/categories/_list', ['categories'=>$model->categories])?>
        </div>
    </div>
    <div class="col-md-12">

        <div class="row col-lg-12">
            <?= Yii::$app->controller->renderPartial('@app/views/pharmacies/_pharmacy_location_search_form', [
                'searchModel'=>$stockSearchModel->pharmacySearch])?>
        </div>

        <h2>Pharmacies with <?=$model->name?></h2>

        <?php if($stockSearchModel->pharmacySearch->location != null):?>
            <h4 class="text-success pull-right col-xs-12"><i class="fa fa-map-marker"></i> Near
                <?=$stockSearchModel->pharmacySearch->location?>
            </h4>
        <?php endif;?>

        <?= GridView::widget([
            'dataProvider' => $stockDataProvider,
            'filterModel' => $stockSearchModel,
            'columns' => [
                ['class' => 'yii\grid\SerialColumn'],

                //'id',
                ['attribute'=>'pharmacy_id', 'format'=>'raw',
                    'filter'=>Yii::$app->controller->renderPartial('@app/views/pharmacies/_filter', [
                        'searchModel'=>$stockSearchModel->pharmacySearch]),
                    'value'=>function(Stock $stock){
                            return Html::a($stock->pharmacy->name, ['/pharmacies/info',
                                'id'=>$stock->pharmacy_id,
                                'Drug[name]'=>$stock->drug->name
                            ]);
                    }
                ],
                ['label'=>'Location', 'value'=>'pharmacy.location'],
                ['label'=>'Distance', 'value'=>'pharmacy.searchedLocationDistance'],
                ['label'=>'In Stock', 'value'=>function(Stock $stock){
                    return $stock->quantity.' '. Constants::measures()[$stock->measure];
                }],
                'unit_cost'
            ],
        ]); ?>
    </div>

</div>

views/drugs/search.php
<?php

use app\models\Drug;
use yii\helpers\Html;
use yii\grid\GridView;
use yii\widgets\ListView;

/* @var $this yii\web\View */
/* @var $searchModel app\models\search\Drug */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Search';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="drug-index">

    <h2 class="text-center"><?= Html::encode($this->title) ?></h2>
    <span class="hint-block text-center">Medicine or Health Conditions</span>
    <br>
    <div class="com-md-8">
        <?= $this->render('_search', ['model' => $searchModel]); ?>
    </div>
    <br>

    <?= ListView::widget([
        'dataProvider' => $dataProvider,
        'options' => [
            'tag' => 'div',
            'class' => 'list-wrapper',
            'id' => 'list-wrapper',
        ],
        'layout' => "{pager}\n{summary}\n{items}\n{pager}",
        'itemView' => '_drug_search_view',
    ]); ?>
</div>

views/drugs/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Drug */

$this->title = 'Update Drug: ' . $model->name;
$this->params['breadcrumbs'][] = ['label' => 'Drugs', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->name, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="drug-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/drugs/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Drug */

$this->title = $model->name;
$this->params['breadcrumbs'][] = ['label' => 'Drugs', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="drug-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'id' => $model->id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'id',
            'name',
            'description:ntext',
            'reference',
        ],
    ]) ?>

</div>